class Message:

    def __init__( self, conn = None, msg = None, buffer = None ):
        if conn is not None:
            self._conn = conn
            self._buffer = ""
        elif msg is not None:
            self._conn = None
            self._buffer = msg.getmessage()
        else:
            self._buffer = buffer
        self.readcommand()
        self.readheaders()
        self.readcontent()
    
    def readdata( self ):

        self._buffer = self._buffer + self._conn.recv( 1024 )


    def getdata( self, length):
    
        while 1:
            if len(self._buffer) >= length:
                data = self._buffer[0:length]
                self._buffer = self._buffer[length:]
                return data
            else:
                self.readdata()


    def readline( self ):
    
        while 1:
            if self._buffer == "":
                self.readdata()
            
            pos = string.find( self._buffer, "\r\n" )
        
            if pos <> -1:
                line = self._buffer[:pos]
                self._buffer = self._buffer[pos+2:]
                return line
        
            self.readdata()


    def readcommand( self ):
    
        line = self.readline()
        bits = string.split( line )
        self._command = bits[0]
        self._arguments = bits[1:]


    def readheaders( self ):

        self._headerdict = {}
        self._headerlist = []
        
        while 1:
            line = self.readline()
            if line == "":
                break
            if line[0] in string.whitespace:
                header[1] = header[1] + string.lstrip(line)
            else:
                (field,value) = string.split( line, ":", 1 )
                header = [string.lower(field), string.strip(value)]
                self._headerlist.append( header )
                self._headerdict[string.lower(field)] = header


    def readcontent( self ):
        
        length = self.getheader('content-length')
        if length:
            self._content = self.getdata( int(length) )
        else:
            self._content = ""

    def getcontent( self ):
        return self._content
    
    def getmessage( self ):
    
        msg = self._command + " " + string.join( self._arguments ) + "\r\n"
        
        for header in self._headerlist:
            msg = msg + "%s: %s\r\n" % (header[0], header[1])

        msg = msg + "\r\n" + self._content
        
        return msg
        

    def getheader( self, field ):
        
        name = string.lower( field )
        if self._headerdict.has_key( name ):
            return self._headerdict[name][1]
        else:
            return None

    def addheader( self, field, value ):
        header = [string.lower(field), string.strip(value)]
        self._headerlist.append( header )
        self._headerdict[string.lower(field)] = header

    def delheader( self, field ):
        name = string.lower( field )
        if self._headerdict.has_key( name ):
	    header = self._headerdict[name]
	    self._headerlist.remove(header)
            del self._headerdict[name]

    def setheader( self, field, value ):
        
        self._headerdict[string.lower(field)][1] = value


    def getcommand( self ):

        return self._command
    
    
    def setcommand( self, command ):

        self._command = command
    
    
    def getargs( self ):
    
        return self._arguments


    def setargs( self, args ):

        self._arguments = args
    
